# Dynamically Generated
@builtin "number.ne"
@builtin "string.ne"
@builtin "whitespace.ne"
@{%
    function compact(v) {
        if (Array.isArray(v)) {
            return v.reduce((a, v) => (v === null || v === undefined || (v && v.length === 0) ) ? a : (a.push(v), a), []);
        } else {
            return v;
        }
    }

    function flatten(v) {
        let r;
        if (Array.isArray(v)) {
            r = v.reduce((a,v) => (a.push(...((v && Array.isArray(v)) ? flatten(v) : [v])), a), []);
        } else {
            r = v;
        }
        r = compact(r);
        return r;
        }
%}


rule -> rule0 rule1 rule2 rule3 rule4 rule5 rule6 rule7 rule8 rule9 rule10 rule11 rule12 rule13 rule14 rule15 rule16 rule17 rule18 rule19 rule20 rule21 rule22 rule23 rule24 rule25 rule26 
{% ([ rule0,rule1,rule2,rule3,rule4,rule5,rule6,rule7,rule8,rule9,rule10,rule11,rule12,rule13,rule14,rule15,rule16,rule17,rule18,rule19,rule20,rule21,rule22,rule23,rule24,rule25,rule26 ]) => {
    return {
        $class: "org.accordproject.copyrightlicense.CopyrightLicenseContract",
        contractId : "00ed003c-10b6-490b-80cb-53234f58d7e8",
        effectiveDate : rule1,
        licenseeName : rule3,
        licenseeState : rule5,
        licenseeEntityType : rule7,
        licenseeAddress : rule9,
        licensorName : rule11,
        licensorState : rule13,
        licensorEntityType : rule15,
        licensorAddress : rule17,
        territory : rule19,
        purposeDescription : rule21,
        workDescription : rule23,
        paymentClause : rule25,
    };
}
%}

paymentClause -> paymentClause0 paymentClause1 paymentClause2 paymentClause3 paymentClause4 paymentClause5 paymentClause6 
{% ([ paymentClause0,paymentClause1,paymentClause2,paymentClause3,paymentClause4,paymentClause5,paymentClause6 ]) => {
    return {
        $class: "org.accordproject.copyrightlicense.PaymentClause",
        clauseId : "3ad06a90-19ab-478e-b8a1-7eef01ed21cd",
        amountText : paymentClause1,
        amount : paymentClause3,
        paymentProcedure : paymentClause5,
    };
}
%}

ROOT -> rule0 
{% ([ rule0 ]) => {
    return {
        
        
    };
}
%}



rule0 -> "Copyright License Agreement\n\nThis COPYRIGHT LICENSE AGREEMENT (the \"Agreement\"), dated as of " 


rule1 -> DateTime {% id %} # effectiveDate 


rule2 -> " (the \"Effective Date\"), is made by and between " 


rule3 -> String {% id %} # licenseeName 


rule4 -> " (\"Licensee\"), a " 


rule5 -> String {% id %} # licenseeState 


rule6 -> " " 


rule7 -> String {% id %} # licenseeEntityType 


rule8 -> " with offices located at " 


rule9 -> String {% id %} # licenseeAddress 


rule10 -> ", and " 


rule11 -> String {% id %} # licensorName 


rule12 -> " (\"Licensor\"), a " 


rule13 -> String {% id %} # licensorState 


rule14 -> " " 


rule15 -> String {% id %} # licensorEntityType 


rule16 -> " with offices located at " 


rule17 -> String {% id %} # licensorAddress 


rule18 -> ".\n\nWHEREAS, Licensor solely and exclusively owns or controls the Work (as defined below) and wishes to grant to Licensee a license to the Work, and Licensee wishes to obtain a license to the Work for the uses and purposes described herein, each subject to the terms and conditions set forth herein.\n\nNOW, THEREFORE, in consideration of the mutual covenants, terms, and conditions set forth herein, and for other good and valuable consideration, the receipt and sufficiency of which are hereby acknowledged, the parties agree as follows:\n\n1. License.\n\n1.1. Grant of Rights. Subject to the terms and conditions of this Agreement, Licensor hereby grants to Licensee and its affiliates during the Term (as defined below) an exclusive, transferable right and license in the " 


rule19 -> String {% id %} # territory 


rule20 -> " (the \"Territory\"), to reproduce, publicly perform, display, transmit, and distribute the Work, including translate, alter, modify, and create derivative works of the Work, through all media now known or hereinafter developed for purposes of " 


rule21 -> String {% id %} # purposeDescription 


rule22 -> ". The \"Work\" is defined as " 


rule23 -> String {% id %} # workDescription 


rule24 -> ".\n\n1.2. Permissions. Licensor has obtained from all persons and entities who are, or whose trademark or other property is, identified, depicted, or otherwise referred to in the Work, such written and signed licenses, permissions, waivers, and consents (collectively, \"Permissions\" and each, individually, a \"Permission\"), including those relating to publicity, privacy, and any intellectual property rights, as are or reasonably may be expected to be necessary for Licensee to exercise its rights in the Work as permitted under this Agreement, without incurring any payment or other obligation to, or otherwise violating any right of, any such person or entity.\n\n2. Copyright Notices. Licensee shall ensure that its use of the Work is marked with the appropriate copyright notices specified by Licensor in a reasonably prominent position in the order and manner provided by Licensor. Licensee shall abide by the copyright laws and what are considered to be sound practices for copyright notice provisions in the Territory. Licensee shall not use any copyright notices that conflict with, confuse, or negate the notices Licensor provides and requires hereunder.\n\n3. " 


paymentClause0 -> "Payment. As consideration in full for the rights granted herein, Licensee shall pay Licensor a one-time fee in the amount of " 


paymentClause1 -> String {% id %} # amountText 


paymentClause2 -> " (" 


paymentClause3 -> MonetaryAmount {% id %} # amount 


paymentClause4 -> ") upon execution of this Agreement, payable as follows: " 


paymentClause5 -> String {% id %} # paymentProcedure 


paymentClause6 -> ". " 


rule25 -> paymentClause {% id %}
 


rule26 -> " \n\n4. General.\n\n4.1. Interpretation. For purposes of this Agreement, (a) the words \"include,\" \"includes,\" and \"including\" are deemed to be followed by the words \"without limitation\"; (b) the word \"or\" is not exclusive; and (c) the words \"herein,\" \"hereof,\" \"hereby,\" \"hereto,\" and \"hereunder\" refer to this Agreement as a whole. This Agreement is intended to be construed without regard to any presumption or rule requiring construction or interpretation against the party drafting an instrument or causing any instrument to be drafted.\n\n4.2. Entire Agreement. This Agreement, including and together with any related attachments, constitutes the sole and entire agreement of the parties with respect to the subject matter contained herein, and supersedes all prior and contemporaneous understandings, agreements, representations, and warranties, both written and oral, with respect to such subject matter. \n\n4.3. Severability. If any term or provision of this Agreement is invalid, illegal, or unenforceable in any jurisdiction, such invalidity, illegality, or unenforceability will not affect the enforceability of any other term or provision of this Agreement, or invalidate or render unenforceable such term or provision in any other jurisdiction. [Upon a determination that any term or provision is invalid, illegal, or unenforceable, [the parties shall negotiate in good faith to/the court may] modify this Agreement to effect the original intent of the parties as closely as possible in order that the transactions contemplated hereby be consummated as originally contemplated to the greatest extent possible.]\n\n4.4. Assignment. Licensee may freely assign or otherwise transfer all or any of its rights, or delegate or otherwise transfer all or any of its obligations or performance, under this Agreement without Licensor's consent. This Agreement is binding upon and inures to the benefit of the parties hereto and their respective permitted successors and assigns.\n\n" 


PaymentRequest -> String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.copyrightlicense.PaymentRequest",
        transactionId : data[0],
        timestamp : data[2]
    };
}
%}


PayOut -> MonetaryAmount  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.copyrightlicense.PayOut",
        amount : data[0],
        transactionId : data[2],
        timestamp : data[4]
    };
}
%}


CopyrightLicenseContract -> DateTime  __  String  __  String  __  String  __  String  __  String  __  String  __  String  __  String  __  String  __  String  __  String  __  PaymentClause  __  String  __  Participant:* 

{% ( data ) => {
    return {
        $class: "org.accordproject.copyrightlicense.CopyrightLicenseContract",
        effectiveDate : data[0],
        licenseeName : data[2],
        licenseeState : data[4],
        licenseeEntityType : data[6],
        licenseeAddress : data[8],
        licensorName : data[10],
        licensorState : data[12],
        licensorEntityType : data[14],
        licensorAddress : data[16],
        territory : data[18],
        purposeDescription : data[20],
        workDescription : data[22],
        paymentClause : data[24],
        contractId : data[26],
        parties : data[28]
    };
}
%}


PaymentClause -> String  __  MonetaryAmount  __  String  __  String 

{% ( data ) => {
    return {
        $class: "org.accordproject.copyrightlicense.PaymentClause",
        amountText : data[0],
        amount : data[2],
        paymentProcedure : data[4],
        clauseId : data[6]
    };
}
%}


AccordContractState -> String 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.contract.AccordContractState",
        stateId : data[0]
    };
}
%}


PaymentObligation -> MonetaryAmount  __  String  __  String  __  String  __  String  __  DateTime:?  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.PaymentObligation",
        amount : data[0],
        description : data[2],
        contract : data[4],
        promisor : data[6],
        promisee : data[8],
        deadline : data[10],
        eventId : data[12],
        timestamp : data[14]
    };
}
%}


NotificationObligation -> String  __  String  __  String  __  String  __  String  __  DateTime:?  __  String  __  DateTime 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.NotificationObligation",
        title : data[0],
        message : data[2],
        contract : data[4],
        promisor : data[6],
        promisee : data[8],
        deadline : data[10],
        eventId : data[12],
        timestamp : data[14]
    };
}
%}


Payload -> AccordContract  __  Request  __  AccordContractState:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.Payload",
        contract : data[0],
        request : data[2],
        state : data[4]
    };
}
%}


Success -> Response  __  AccordContractState  __  Event:+ 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.Success",
        response : data[0],
        state : data[2],
        emit : data[4]
    };
}
%}


Failure -> ErrorResponse 

{% ( data ) => {
    return {
        $class: "org.accordproject.cicero.runtime.Failure",
        error : data[0]
    };
}
%}


MonetaryAmount -> Double  __  CurrencyCode 

{% ( data ) => {
    return {
        $class: "org.accordproject.money.MonetaryAmount",
        doubleValue : data[0],
        currencyCode : data[2]
    };
}
%}


CurrencyCode -> "AED" {% id %} | "AFN" {% id %} | "ALL" {% id %} | "AMD" {% id %} | "ANG" {% id %} | "AOA" {% id %} | "ARS" {% id %} | "AUD" {% id %} | "AWG" {% id %} | "AZN" {% id %} | "BAM" {% id %} | "BBD" {% id %} | "BDT" {% id %} | "BGN" {% id %} | "BHD" {% id %} | "BIF" {% id %} | "BMD" {% id %} | "BND" {% id %} | "BOB" {% id %} | "BOV" {% id %} | "BRL" {% id %} | "BSD" {% id %} | "BTN" {% id %} | "BWP" {% id %} | "BYN" {% id %} | "BZD" {% id %} | "CAD" {% id %} | "CDF" {% id %} | "CHE" {% id %} | "CHF" {% id %} | "CHW" {% id %} | "CLF" {% id %} | "CLP" {% id %} | "CNY" {% id %} | "COP" {% id %} | "COU" {% id %} | "CRC" {% id %} | "CUC" {% id %} | "CUP" {% id %} | "CVE" {% id %} | "CZK" {% id %} | "DJF" {% id %} | "DKK" {% id %} | "DOP" {% id %} | "DZD" {% id %} | "EGP" {% id %} | "ERN" {% id %} | "ETB" {% id %} | "EUR" {% id %} | "FJD" {% id %} | "FKP" {% id %} | "GBP" {% id %} | "GEL" {% id %} | "GHS" {% id %} | "GIP" {% id %} | "GMD" {% id %} | "GNF" {% id %} | "GTQ" {% id %} | "GYD" {% id %} | "HKD" {% id %} | "HNL" {% id %} | "HRK" {% id %} | "HTG" {% id %} | "HUF" {% id %} | "IDR" {% id %} | "ILS" {% id %} | "INR" {% id %} | "IQD" {% id %} | "IRR" {% id %} | "ISK" {% id %} | "JMD" {% id %} | "JOD" {% id %} | "JPY" {% id %} | "KES" {% id %} | "KGS" {% id %} | "KHR" {% id %} | "KMF" {% id %} | "KPW" {% id %} | "KRW" {% id %} | "KWD" {% id %} | "KYD" {% id %} | "KZT" {% id %} | "LAK" {% id %} | "LBP" {% id %} | "LKR" {% id %} | "LRD" {% id %} | "LSL" {% id %} | "LYD" {% id %} | "MAD" {% id %} | "MDL" {% id %} | "MGA" {% id %} | "MKD" {% id %} | "MMK" {% id %} | "MNT" {% id %} | "MOP" {% id %} | "MRU" {% id %} | "MUR" {% id %} | "MVR" {% id %} | "MWK" {% id %} | "MXN" {% id %} | "MXV" {% id %} | "MYR" {% id %} | "MZN" {% id %} | "NAD" {% id %} | "NGN" {% id %} | "NIO" {% id %} | "NOK" {% id %} | "NPR" {% id %} | "NZD" {% id %} | "OMR" {% id %} | "PAB" {% id %} | "PEN" {% id %} | "PGK" {% id %} | "PHP" {% id %} | "PKR" {% id %} | "PLN" {% id %} | "PYG" {% id %} | "QAR" {% id %} | "RON" {% id %} | "RSD" {% id %} | "RUB" {% id %} | "RWF" {% id %} | "SAR" {% id %} | "SBD" {% id %} | "SCR" {% id %} | "SDG" {% id %} | "SEK" {% id %} | "SGD" {% id %} | "SHP" {% id %} | "SLL" {% id %} | "SOS" {% id %} | "SRD" {% id %} | "SSP" {% id %} | "STN" {% id %} | "SVC" {% id %} | "SYP" {% id %} | "SZL" {% id %} | "THB" {% id %} | "TJS" {% id %} | "TMT" {% id %} | "TND" {% id %} | "TOP" {% id %} | "TRY" {% id %} | "TTD" {% id %} | "TWD" {% id %} | "TZS" {% id %} | "UAH" {% id %} | "UGX" {% id %} | "USD" {% id %} | "USN" {% id %} | "UYI" {% id %} | "UYU" {% id %} | "UZS" {% id %} | "VEF" {% id %} | "VND" {% id %} | "VUV" {% id %} | "WST" {% id %} | "XAF" {% id %} | "XAG" {% id %} | "XAU" {% id %} | "XBA" {% id %} | "XBB" {% id %} | "XBC" {% id %} | "XBD" {% id %} | "XCD" {% id %} | "XDR" {% id %} | "XOF" {% id %} | "XPD" {% id %} | "XPF" {% id %} | "XPT" {% id %} | "XSU" {% id %} | "XTS" {% id %} | "XUA" {% id %} | "XXX" {% id %} | "YER" {% id %} | "ZAR" {% id %} | "ZMW" {% id %} | "ZWL" {% id %} 


Organization -> String  __  String:?  __  String:?  __  String:?  __  Place:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.organization.Organization",
        identifier : data[0],
        name : data[2],
        description : data[4],
        duns : data[6],
        place : data[8]
    };
}
%}


PostalAddress -> String:?  __  String:?  __  String:?  __  String:?  __  String:?  __  String:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.address.PostalAddress",
        streetAddress : data[0],
        postalCode : data[2],
        postOfficeBoxNumber : data[4],
        addressRegion : data[6],
        addressLocality : data[8],
        addressCountry : data[10]
    };
}
%}


GeoCoordinates -> PostalAddress:?  __  String:?  __  Double:?  __  Double:?  __  Double:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.geo.GeoCoordinates",
        address : data[0],
        addressCountry : data[2],
        elevation : data[4],
        latitude : data[6],
        longitude : data[8]
    };
}
%}


Place -> PostalAddress:?  __  String:?  __  String:?  __  GeoCoordinates:?  __  String:?  __  String:?  __  String:?  __  String:? 

{% ( data ) => {
    return {
        $class: "org.accordproject.geo.Place",
        address : data[0],
        branchCode : data[2],
        faxNumber : data[4],
        geo : data[6],
        globalLocationNumber : data[8],
        mapUrl : data[10],
        isicsV4 : data[12],
        telephone : data[14]
    };
}
%}


Country -> String  __  CountryCodeISOAlpha2 

{% ( data ) => {
    return {
        $class: "org.accordproject.geo.Country",
        name : data[0],
        optional : data[2]
    };
}
%}


CountryCodeISOAlpha2 -> "AD" {% id %} | "AE" {% id %} | "AF" {% id %} | "AG" {% id %} | "AI" {% id %} | "AL" {% id %} | "AM" {% id %} | "AO" {% id %} | "AQ" {% id %} | "AR" {% id %} | "AS" {% id %} | "AT" {% id %} | "AU" {% id %} | "AW" {% id %} | "AX" {% id %} | "AZ" {% id %} | "BA" {% id %} | "BB" {% id %} | "BD" {% id %} | "BE" {% id %} | "BF" {% id %} | "BG" {% id %} | "BH" {% id %} | "BI" {% id %} | "BJ" {% id %} | "BL" {% id %} | "BM" {% id %} | "BN" {% id %} | "BO" {% id %} | "BQ" {% id %} | "BR" {% id %} | "BS" {% id %} | "BT" {% id %} | "BV" {% id %} | "BW" {% id %} | "BY" {% id %} | "BZ" {% id %} | "CA" {% id %} | "CC" {% id %} | "CD" {% id %} | "CF" {% id %} | "CG" {% id %} | "CH" {% id %} | "CI" {% id %} | "CK" {% id %} | "CL" {% id %} | "CM" {% id %} | "CN" {% id %} | "CO" {% id %} | "CR" {% id %} | "CU" {% id %} | "CV" {% id %} | "CW" {% id %} | "CX" {% id %} | "CY" {% id %} | "CZ" {% id %} | "DE" {% id %} | "DJ" {% id %} | "DK" {% id %} | "DM" {% id %} | "DO" {% id %} | "DZ" {% id %} | "EC" {% id %} | "EE" {% id %} | "EG" {% id %} | "EH" {% id %} | "ER" {% id %} | "ES" {% id %} | "ET" {% id %} | "FI" {% id %} | "FJ" {% id %} | "FK" {% id %} | "FM" {% id %} | "FO" {% id %} | "FR" {% id %} | "GA" {% id %} | "GB" {% id %} | "GD" {% id %} | "GE" {% id %} | "GF" {% id %} | "GG" {% id %} | "GH" {% id %} | "GI" {% id %} | "GL" {% id %} | "GM" {% id %} | "GN" {% id %} | "GP" {% id %} | "GQ" {% id %} | "GR" {% id %} | "GS" {% id %} | "GT" {% id %} | "GU" {% id %} | "GW" {% id %} | "GY" {% id %} | "HK" {% id %} | "HM" {% id %} | "HN" {% id %} | "HR" {% id %} | "HT" {% id %} | "HU" {% id %} | "ID" {% id %} | "IE" {% id %} | "IL" {% id %} | "IM" {% id %} | "IN" {% id %} | "IO" {% id %} | "IQ" {% id %} | "IR" {% id %} | "IS" {% id %} | "IT" {% id %} | "JE" {% id %} | "JM" {% id %} | "JO" {% id %} | "JP" {% id %} | "KE" {% id %} | "KG" {% id %} | "KH" {% id %} | "KI" {% id %} | "KM" {% id %} | "KN" {% id %} | "KP" {% id %} | "KR" {% id %} | "KW" {% id %} | "KY" {% id %} | "KZ" {% id %} | "LA" {% id %} | "LB" {% id %} | "LC" {% id %} | "LI" {% id %} | "LK" {% id %} | "LR" {% id %} | "LS" {% id %} | "LT" {% id %} | "LU" {% id %} | "LV" {% id %} | "LY" {% id %} | "MA" {% id %} | "MC" {% id %} | "MD" {% id %} | "ME" {% id %} | "MF" {% id %} | "MG" {% id %} | "MH" {% id %} | "MK" {% id %} | "ML" {% id %} | "MM" {% id %} | "MN" {% id %} | "MO" {% id %} | "MP" {% id %} | "MQ" {% id %} | "MR" {% id %} | "MS" {% id %} | "MT" {% id %} | "MU" {% id %} | "MV" {% id %} | "MW" {% id %} | "MX" {% id %} | "MY" {% id %} | "MZ" {% id %} | "NA" {% id %} | "NC" {% id %} | "NE" {% id %} | "NF" {% id %} | "NG" {% id %} | "NI" {% id %} | "NL" {% id %} | "NO" {% id %} | "NP" {% id %} | "NR" {% id %} | "NU" {% id %} | "NZ" {% id %} | "OM" {% id %} | "PA" {% id %} | "PE" {% id %} | "PF" {% id %} | "PG" {% id %} | "PH" {% id %} | "PK" {% id %} | "PL" {% id %} | "PM" {% id %} | "PN" {% id %} | "PR" {% id %} | "PS" {% id %} | "PT" {% id %} | "PW" {% id %} | "PY" {% id %} | "QA" {% id %} | "RE" {% id %} | "RO" {% id %} | "RS" {% id %} | "RU" {% id %} | "RW" {% id %} | "SA" {% id %} | "SB" {% id %} | "SC" {% id %} | "SD" {% id %} | "SE" {% id %} | "SG" {% id %} | "SH" {% id %} | "SI" {% id %} | "SJ" {% id %} | "SK" {% id %} | "SL" {% id %} | "SM" {% id %} | "SN" {% id %} | "SO" {% id %} | "SR" {% id %} | "SS" {% id %} | "ST" {% id %} | "SV" {% id %} | "SX" {% id %} | "SY" {% id %} | "SZ" {% id %} | "TC" {% id %} | "TD" {% id %} | "TF" {% id %} | "TG" {% id %} | "TH" {% id %} | "TJ" {% id %} | "TK" {% id %} | "TL" {% id %} | "TM" {% id %} | "TN" {% id %} | "TO" {% id %} | "TR" {% id %} | "TT" {% id %} | "TV" {% id %} | "TW" {% id %} | "TZ" {% id %} | "UA" {% id %} | "UG" {% id %} | "UM" {% id %} | "US" {% id %} | "UY" {% id %} | "UZ" {% id %} | "VA" {% id %} | "VC" {% id %} | "VE" {% id %} | "VG" {% id %} | "VI" {% id %} | "VN" {% id %} | "VU" {% id %} | "WF" {% id %} | "WS" {% id %} | "YE" {% id %} | "YT" {% id %} | "ZA" {% id %} | "ZM" {% id %} | "ZW" {% id %} 



# Basic types
NUMBER -> [0-9] 
{% (d) => {return parseInt(d[0]);}%}

DOUBLE_NUMBER -> NUMBER NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

MONTH -> DOUBLE_NUMBER
DAY -> DOUBLE_NUMBER
YEAR -> DOUBLE_NUMBER DOUBLE_NUMBER
{% (d) => {return '' + d[0] + d[1]}%}

DATE -> MONTH "/" DAY "/" YEAR
{% (d) => {return '' + d[4] + '-' + d[0] + '-' + d[2]}%}

Word -> [\S]:*
{% (d) => {return d[0].join('');}%}

BRACKET_PHRASE -> "[" Word (__ Word):* "]" {% ((d) => {return d[1] + ' ' + flatten(d[2]).join(" ");}) %}

String -> dqstring {% id %}
Double -> decimal {% id %}
Integer -> int {% id %}
Long -> int {% id %}
Boolean -> "true" {% id %} | "false" {% id %}
DateTime -> DATE  {% id %}